function C=binaryop_Nat(A,B,fun)
% function C=binaryop(A,B,fun)
%   element by element generic function
%   fun is either @times, @plus, @minus, @power, @rdivide or @ldivide
  %assert(sum(strcmp(func2str(fun),{'times','power','rdivide','ldivide','plus','minus'}))==1)
  isA3D=fc_linalg3D.is3Darray(A);
  isB3D=fc_linalg3D.is3Darray(B);
  assert( isA3D || isB3D , 'One of the two parameters must be a 3D-array')
  if (isA3D && isB3D) % Both 3D-arrays with same size
    assert( any(size(A)==size(B)) )
    C=fun(A,B);
    return
  end
  %if isA3D && size(A,1)~=size(B,1), B=reshape(B,[1 size(B)]);end
  %if isB3D && size(A,1)~=size(B,1), A=reshape(A,[1 size(A)]);end
%    if isA3D && size(A,1)~=size(B,1), B=redim(B,size(A,1));end
%    if isB3D && size(A,1)~=size(B,1), A=redim(A,size(B,1));end
  if isA3D, B=fc_linalg3D.redim(B,size(A));else, A=fc_linalg3D.redim(A,size(B));end
  %whos
  C=fun(A,B);
end

%  function X=redim(X,Y) % Y is 3D array 
%    sY=size(Y);sX=size(X);
%    if ~fc_tools.comp.isOctave() && verLessThan('matlab','9.1.0')
%      if ndims(X)==2
%        irp=[1 1 sY(3)];
%        if sX(1)==1, irp(1)=sY(1);end
%        if sX(2)==1, irp(2)=sY(2);end
%        X=repmat(X,irp);
%      else
%        irp=[1 1 1];
%        if sX(1)==1, irp(1)=sY(1);end
%        if sX(2)==1, irp(2)=sY(2);end
%        if sX(3)==1, irp(3)=sY(3);end
%        X=repmat(X,irp);
%      end
%    end
%  end
