function A=rand(N,m,n,varargin)
  % Return a 3D-array  with random elements uniformly distributed on the
  %   interval (a, b). By default a=0 and b=1.
  p = inputParser;
  p.addParamValue('a',0,@isscalar); % 
  p.addParamValue('b',1,@isscalar); %
  p.parse(varargin{:});
  R=p.Results;
  A=R.a+(R.b-R.a)*rand(N,m,n);
end
